/*

<The Virtual Lightbox Applet: An image editing applet>
    Copyright (C) <2003>  <University of Maryland>
@Author: Amit Kumar	
Code Released under GPL
@date Jan 19th 2003
*/


/*
    <The Virtual Lightbox: An image editing whiteboard application>
    Copyright (C) <2001>  <University of Kentucky>
	Mathew G. Kirschenbaum, Jerzy W. Jaromczyk, Amit Kumar	
	
 
*/



import java.awt.*;
import java.awt.image.*;

abstract class Convolver implements ImageConsumer, PlugInFilter {
  int width, height;
  int imgpixels[], newimgpixels[];

  abstract void convolve();  // filter goes here...
  
  public Image filter(javax.swing.JComponent a, Image in, double val) {
    in.getSource().startProduction(this);
    waitForImage();
    newimgpixels = new int[width*height];

    try {
      convolve();
    } catch (Exception e) {
      System.out.println("Convolver failed: " + e);
      e.printStackTrace();
    }

    return a.createImage(
      new MemoryImageSource(width, height, newimgpixels, 0, width));
  }

  synchronized void waitForImage() {
    try { wait(); } catch (Exception e) { };
  }

  public void setProperties(java.util.Hashtable dummy) { }
  public void setColorModel(ColorModel dummy) { }
  public void setHints(int dummy) { }

  public synchronized void imageComplete(int dummy) {
    notifyAll();
  }

  public void setDimensions(int x, int y) {
    width = x;
    height = y;
	System.out.println("x,y"+x+" " +y);
    imgpixels = new int[x*y];
  }

  public void setPixels(int x1, int y1, int w, int h, 
    ColorModel model, byte pixels[], int off, int scansize) {
    int pix, x, y, x2, y2, sx, sy;
	System.out.println("x1, y1, x2, y2"+x1+" "+w+" "+y1+" "+h);
    x2 = x1+w;
    y2 = y1+h;
    sy = off;
   for(y=y1; y<y2; y++) {
	  System.out.println("loop y: "+y);
      sx = sy;
      for(x=x1; x<x2; x++) {
        pix = model.getRGB(pixels[sx++]);
        if((pix & 0xff000000) == 0)
            pix = 0x00ffffff;
        imgpixels[y*width+x] = pix;
      }
      sy += scansize;
    }
  }

  public void setPixels(int x1, int y1, int w, int h, 
    ColorModel model, int pixels[], int off, int scansize) {
    int pix, x, y, x2, y2, sx, sy;

    x2 = x1+w;
    y2 = y1+h;
    sy = off;
    for(y=y1; y<y2; y++) {
      sx = sy;
      for(x=x1; x<x2; x++) {
        pix = model.getRGB(pixels[sx++]);
        if((pix & 0xff000000) == 0)
            pix = 0x00ffffff;
        imgpixels[y*width+x] = pix;
      }
      sy += scansize;
    }
  }
}
