/*

<The Virtual Lightbox Applet: An image editing applet>
	Copyright (C) <2003>  <University of Maryland>
@Author: Amit Kumar	
Code Released under GPL
@date Jan 4th 2004 @JMN
**/


import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;


public class ImageFileView extends FileView {
	ImageIcon jpgIcon;
	ImageIcon gifIcon;
	ImageIcon tiffIcon;
	ImageIcon pngIcon;
	
	private void setIcon() {
		ClassLoader cl = this.getClass().getClassLoader();
		jpgIcon = Utils.createImageIcon(cl.getResource("applet-images/jpgIcon.gif"));
		gifIcon = Utils.createImageIcon(cl.getResource("applet-images/gifIcon.gif"));
		tiffIcon = Utils.createImageIcon(cl.getResource("applet-images/tiffIcon.gif"));
		pngIcon = Utils.createImageIcon(cl.getResource("applet-images/pngIcon.png"));		
	}


	public ImageFileView(){
		super();
		setIcon();
	}

	
   

    public String getName(File f) {
        return null; //let the L&F FileView figure this out
    }

    public String getDescription(File f) {
        return null; //let the L&F FileView figure this out
    }

    public Boolean isTraversable(File f) {
        return null; //let the L&F FileView figure this out
    }

    public String getTypeDescription(File f) {
        String extension = Utils.getExtension(f);
        String type = null;

        if (extension != null) {
            if (extension.equals(Utils.jpeg) ||
                extension.equals(Utils.jpg)) {
                type = "JPEG Image";
            } else if (extension.equals(Utils.gif)){
                type = "GIF Image";
            } else if (extension.equals(Utils.tiff) ||
                       extension.equals(Utils.tif)) {
                type = "TIFF Image";
            } else if (extension.equals(Utils.png)){
                type = "PNG Image";
            }
        }
        return type;
    }

    public Icon getIcon(File f) {
        String extension = Utils.getExtension(f);
        Icon icon = null;

        if (extension != null) {
            if (extension.equals(Utils.jpeg) ||
                extension.equals(Utils.jpg)) {
                icon = jpgIcon;
            } else if (extension.equals(Utils.gif)) {
                icon = gifIcon;
            } else if (extension.equals(Utils.tiff) ||
                       extension.equals(Utils.tif)) {
                icon = tiffIcon;
            } else if (extension.equals(Utils.png)) {
                icon = pngIcon;
            }
        }
        return icon;
    }
}
