/*

<The Virtual Lightbox Applet: An image editing applet>
Copyright (C) <2003>  <University of Maryland>
@Author: Amit Kumar	
Code Released under GPL
@date Jan 19th 2003
@date-modified Dec 18th 2003 @ABD
@date-modified Dec 25th 2003 @DEL
@date-modified Dec 29th 2003 @JMN
@last-date-modified 2nd of Jan 2004 @JMN
*/


/*  <The Virtual Lightbox: An image editing whiteboard application>
    Copyright (C) <2001>  <University of Kentucky>
	Mathew G. Kirschenbaum, Jerzy W. Jaromczyk, Amit Kumar	
    @Modified by Amit Kumar Jan 11 2003 for lightapp @JGA
*/


import java.awt.*;
import java.util.*;
import javax.swing.ImageIcon;
import javax.swing.JComponent;




/** Image Object stored in vector */

class LbImage extends JComponent
{
ImageIcon image;
String imageFile;
String imageFullFileName;
ImageOp imageop;
ImageCoordinate imageCoordinate;
String owner;
int imageResolution;
String title;
String codebase;
public LbImage(ImageIcon img,String fullName, String title, String clientName, int imgRes,String cbase)
{
	image = img;	
	imageFullFileName = fullName;
	imageFile = processFileName(fullName);
	imageop = new  ImageOp(100,0,0,true,false,false,0,0);
	owner = clientName;
	imageCoordinate = new ImageCoordinate(0,0,img.getIconWidth(),
	img.getIconHeight());
	imageResolution = imgRes;
	codebase = cbase;
	setTitle(title);	
}

public Rectangle getBounds(){
	return  new Rectangle(imageCoordinate.lx, imageCoordinate.ly
	,imageCoordinate.hx, imageCoordinate.hy); 
 }

public void setImageIcon(ImageIcon img)
{
	image = img;	
}

public  ImageIcon getImageIcon()
{
	return image;
}
/** return full path */
public String getFileName()
{
	return imageFullFileName;
}


public void setVisible(boolean val)
{
	imageop.setVisible(val); 
}

public void setInVisible()
{
	imageop.setVisible(false); 
}

public boolean isVisible()
{
	return imageop.isVisible();
}

public void toggle(){
if(isVisible()){
	imageop.setVisible(false); 
}else{
	imageop.setVisible(true); 
}
}

public void setInvert(boolean val)
{
	imageop.setInvert(val); 
}

public boolean isInvert()
{
	return imageop.IsInvert();
}

public void setGreyscale()
{
	imageop.setgreyscale(true); 
}

public void setGreyscale(boolean val)
{
	imageop.setgreyscale(val); 
}
public void setColor()
{
	imageop.setgreyscale(false); 
}

public boolean isGreyscale()
{
	return imageop.Isgreyscale();
}

public void setScreenResolution(int scr)
{
	imageop.setScreenResolution(scr);
}

public int getScreenResolution()
{
	return imageop.getScreenResolution();
}

public int magWidth()
{
	return (int) ((double) image.getIconWidth() 
	* imageop.getScreenResolution() / imageResolution + 0.5); 
}

public int magHeight()
{
	return (int) ((double) image.getIconHeight() 
	* imageop.getScreenResolution() /imageResolution + 0.5); 
}

public int Width()
{
	return image.getIconWidth();
}

public int Height()
{
	return image.getIconHeight(); 
}


public void setContrastVal(int val)
{
	imageop.setContrastVal(val);
}

public int getContrastVal()
{
	return imageop.getContrastVal();
}

public void setBrightVal(int val)
{
	imageop.setBrightVal(val);
}

public int getBrightVal()
{
	return imageop.getBrightVal();
}

public void setPivot(int x, int y)
{   //System.out.println("Changing remote pivot ....");
	//System.out.println("pivot is : " + (x-getLx()) + "  " + (y-getLy()) );
	imageop.setPivot(x-getLx(),y-getLy());
}

public Point getPivot()
{
	return imageop.getPivot();
}

public int getPivotX()
{
	return imageop.getPivotX();
}

public String getTitle(){
	return title;
	
}

public int getPivotY()
{
	return imageop.getPivotY();
}

public void setImageCoordinate(int x, int y)
{
	imageCoordinate.setImageCoordinate(x,y, x+image.getIconWidth(),
	y+image.getIconHeight());
}

public void setImageCoordinate(int x, int y, boolean var)
{
  	if(var == true)
	imageCoordinate.setImageCoordinate(x-getPivotX(),y-getPivotY(),
	x+image.getIconWidth()+getPivotX(),y+image.getIconHeight()+getPivotY());
}


public void setImageCoordinate(int lx, int ly, int hx, int hy)
{
	imageCoordinate.setImageCoordinate(lx,ly,hx,hy);
}

public Point getUpper()
{
return new Point(imageCoordinate.getLx(), imageCoordinate.getLy());
}

public Point getLower()
{
return new Point(imageCoordinate.getHx(), imageCoordinate.getHy());
}

public int getLx()
{
imageCoordinate.toString();
return imageCoordinate.getLx();
}

public int getHx()
{
return imageCoordinate.getHx();
}

public int getLy()
{
return imageCoordinate.getLy();
}

public int getHy()
{
return imageCoordinate.getHy();
}

protected String processFileName( String fullPath) {
    String rawImageName = "errorImage";
    String delimiters = "/";   
    String text = fullPath;
    StringTokenizer tokenCollection;

    char[] delme = new char[1000];     
    delme = text.toCharArray();
    for(int i =0; i< text.length();i++)
    {
      if(delme[i] == '\\'){
       delimiters = ":\\";	// recieving file from windows
       break;
       }
      if(delme[i] == '/'){
       delimiters = "/";	// recieving file from unix and clones
       break;
       }
    }
	if ( delimiters == null ) {
	tokenCollection = new StringTokenizer( text );
	}
	else {
	tokenCollection = new StringTokenizer( text, delimiters );
	}

	while ( tokenCollection.hasMoreTokens() )
	{
	rawImageName =   tokenCollection.nextToken();
	}
	return rawImageName;
}
	
public boolean isSelected(int thisX, int thisY)
{
 if(thisX >= imageCoordinate.lx 
   && thisX  <=  imageCoordinate.lx + magWidth() 
   && thisY >= imageCoordinate.ly 
   && thisY  <=imageCoordinate.ly + magHeight()
   && imageop.visible )
	return true;
	else
	return false;
}

/**
 * @param title2
 */
public void setTitle(String title2) {
	title = title2;
	
}

/**
 * @return codebase for the image
 */
public String getCodeBase() {	
	return codebase;
}


}
