/*
<The Virtual Lightbox Applet: An image editing applet>
    Copyright (C) <2003>  <University of Maryland>
@Author: Amit Kumar	
Code Released under GPL
@date Jan 19th 2003
@date-modified Jan 23rd  2003
@date-modified Dec 15th  2003
@date-modified Dec 31st  2003 @JMN
@last date-modified Jan 27th  2004 @CP
*/


/*  <The Virtual Lightbox: An image editing whiteboard application>
     Copyright (C) <2001>  <University of Kentucky>
	Mathew G. Kirschenbaum, Jerzy W. Jaromczyk, Amit Kumar	
*/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.ImageIcon;

import java.io.File;
import java.net.*;


/**
LbImageManager is the place holder for the images 
 */

class LbImageManager extends JPanel implements MouseListener, MouseMotionListener,ActionListener
{
	private boolean displayTools;
	final Color frameColor = new Color(0,255,0);
	final int FRAME_WIDTH = 2;
    final int FUZZ = 0; // sync  
	final int  MIN_MAGNIFY = 5;//minimum demagnification that you can get
	final int SCALE_MIN = 10;
    final int SCALE_MAX = 1000;
	final ImageIcon crossIcon = new ImageIcon(this.getClass().getClassLoader().getResource("applet-images/cross.jpg"));
	
	final double TILE_X = 256;
	int width = 1024;
	int height = 768;
// snap gets set to this
  int xGrid=1;
  int yGrid =1;
  private int prevX, prevY;
  public Vector imageList;
  public Vector selectedImage;
  private String currentImage;
  int maxX;
  int maxY;
  int numSelected;
  LbImage lbimage; // current selected lbimage
  //PlanarImage curimg;
  int countofselected	= 0;
  int mode = 1;	
  
  int magnifyVal =10;
  int brightVal =10;
  int contrastVal =10;
  int scale = 100;
  int x0,y0;
  int ImageRes, ScreenRes;
  URL codebase;
  int lastX, lastY;
  private WorkSpace wkspace;
  private ButtonPanel bp;
  String documentDir=null;

  public void saveWorkSpace(){
  	wkspace.createWorkSpace();  	
  }
  
  public void setButtonPanel(ButtonPanel bp){
  this.bp = bp;  
  }
  
  public ButtonPanel getButtonPanel(){
  return bp; 
  }
  
  public void openWorkSpace(){
	  wkspace.openWorkSpace();  	
	}
  
  
  
  public LbImageManager()
  {
	imageList = new Vector(20,2);
	maxX = 600;
	maxY = 600;
	ScreenRes = ImageRes = Toolkit.getDefaultToolkit().getScreenResolution();
	addMouseListener(this);	
	addMouseMotionListener(this);		
  }
  
  

  public void setCodeBase(URL code){
	codebase = code;
  }

  public void setWidthHeight(int w, int h)
  {
	width = w;
	height = h;
  }

  	public synchronized void paintComponent(Graphics g)
	{
	super.paintComponent(g);
	Graphics2D g2 = (Graphics2D)g;
	LbImage alllbimg;
	for(int num=0; num<getNumImage();num++)
	{
	alllbimg = getLbImage(num);
	
	if(alllbimg.isVisible() && alllbimg != lbimage)
	g2.drawImage(alllbimg.getImageIcon().getImage(),alllbimg.getLx(), alllbimg.getLy(), alllbimg.magWidth(),alllbimg.magHeight(),this);	
	}
	
	if(lbimage != null && lbimage.isVisible()){
	g2.setColor(frameColor);
	g2.fillRect(lbimage.getLx() - FRAME_WIDTH,lbimage.getLy() - FRAME_WIDTH, lbimage.magWidth() + FRAME_WIDTH * 2, lbimage.magHeight() + FRAME_WIDTH * 2 );
	g2.drawImage(lbimage.getImageIcon().getImage(),lbimage.getLx(), lbimage.getLy(), lbimage.magWidth(),lbimage.magHeight(),this);
	//g2.setColor(Color.GRAY);
	//g2.fillRect(lbimage.getLx()-FRAME_WIDTH, lbimage.getLy()-FRAME_WIDTH-10,10,10);
	//g2.drawImage(crossIcon.getImage(),lbimage.getLx()-FRAME_WIDTH, lbimage.getLy()-FRAME_WIDTH-10,crossIcon.getIconWidth(),crossIcon.getIconHeight(),this);
	this.setToolTipText(lbimage.getTitle());
	}
	

	}
 
  public void tileImages()
  {
	Point upoint = new Point(0,0);
	
	int count=0;
	for(int num =0 ; num < getNumImage(); num++)
	{
	count++;
    setTileMagnification(num);
	
	
	int val = num/2 ;
	
	if(count== 2)
	{
	  count =0;	
	  upoint.x = (int)TILE_X * val;
  	  upoint.y = (int)TILE_X;
	}else{
	  upoint.x = (int)TILE_X * val;
  	  upoint.y = 0;
	}
    
    updateCoordinate(upoint.x, upoint.y,num);
	this.setPivot(upoint.x/2,upoint.y/2,num);
	}
  }


public void actionPerformed ( ActionEvent e) {
          
String command = e.getActionCommand();


// ToolBox commands

if(command.equals("tile"))
{
tileImages();
this.repaint();
return;
}

//minus plus contrast bright 
if(command.equals("bright"))
{
bright();
return;
}
	 
if(command.equals("plus") && (scale < SCALE_MAX))
{
//System.out.println("Pressed Plus magnifyVal is: " + magnifyVal);
scale += magnifyVal;
paintImage();
return; 
}
	 
if(command.equals("minus") && (scale > SCALE_MIN))
{
if((scale - magnifyVal) > MIN_MAGNIFY)
scale -= magnifyVal;
else
scale = MIN_MAGNIFY; 
paintImage();
return;	
}

if(command.equals("contrast"))
{

contrast(); 
return;
}
   

if(command.equals("contrastless"))
{
contrastless(); 
return;
}



if(command.equals("invert"))
{

invert(); 
return;
}

if(command.equals("sharpen"))
{

//sharpen(); 
return;
}

if(command.equals("greyscale"))
{

greyscale(); 
return;
}

  	
if(command.equals("blur"))
{

//blur();
return;
}

//refreshImage gets orignal image back
if(command.equals("refreshImage"))
{
if(lbimage != null)
refreshImage();

return;
}


if(command.equals("savewkspace"))
{
saveWorkSpace();
return;
}

if(command.equals("openwkspace"))
{
openWorkSpace();
this.repaint();
return;
}


if(command.equals("clear"))
{
clearWorkSpace();
this.repaint();
return;
}

if(command.equals("addimage"))
{
addImage();
this.repaint();
return;
}


if(command.equals("Exit"))
{
Object[] options = {"Ok","Cancel"};
int response = JOptionPane.showOptionDialog(null,"Click Ok to exit","Warning",
JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
null,options,options[0]);
if(response == 0)
{
System.out.println("Exiting ...");
System.exit(0);
}else
{
return;
}
return; 
}

//UGLY
if(command.length() > 17){
if(command.substring(0,17).equals("toggle_visibility")){
	String fname = command.substring(17,command.length());
	visible(fname);
  return;
}
}


}


/**
 * remove all the images from the workspace
 */
private void clearWorkSpace() {
	this.imageList.clear();
	if(this.selectedImage != null)
	this.selectedImage.clear();
	this.lbimage=null;
	this.bp.removeAllButton();	
}

public void addImage(){
	System.out.println("Adding new Image");
	String fname = null;
	URL cbase=null;
	File fil[]=null;
	JFileChooser chooser = new JFileChooser();
		 chooser.setDialogTitle("Add Image to Lightbox");
		 chooser.setDialogType(JFileChooser.OPEN_DIALOG);
		 chooser.setToolTipText("Add Image to Lightbox");
		 chooser.addChoosableFileFilter(new ImageFilter());
		 chooser.setAcceptAllFileFilterUsed(false);
		 chooser.setFileView(new ImageFileView());
		 chooser.setMultiSelectionEnabled(true);
		 if(documentDir != null && (new File(documentDir)).exists())
		 chooser.setCurrentDirectory(new File(documentDir));
		   	 	 
		  int returnVal = chooser.showOpenDialog(this);
	
		  if(returnVal == JFileChooser.APPROVE_OPTION) {
		  fil = chooser.getSelectedFiles();				  
		  }else{
			 return ;
		  }
	 
		  if(fil==null){
		  	System.out.println("Image name is null");
		  return ;	
		  }
		  int count =0;
		  int ImageResolution = 100;
	
	for(count=0; count < fil.length; count++){
	      try{			
	      			  if(fil[count].getParentFile().getAbsolutePath().startsWith("/"))
					  cbase = new URL("file:"+fil[count].getParentFile().getAbsolutePath()+"/");
	      			  else
					  cbase = new URL("file:/"+fil[count].getParentFile().getAbsolutePath()+"/");
					  }catch(Exception ex){
						System.out.println(ex.getMessage());				  	
					  }
		  fname = fil[count].getName();
		  

		
	ImageIcon img = null;
	String title= fname;
	img = getImage(cbase.toString(),fname);
	LbImage lbimage = new LbImage(img,fname,title,"self",ImageResolution,cbase.toString());
	addImage(lbimage, new Dimension(img.getIconWidth(),img.getIconHeight()));
	ImageIcon imgsmall = new ImageIcon(img.getImage().getScaledInstance(30,30,Image.SCALE_DEFAULT)); 
	getButtonPanel().addButton(imgsmall,title,fname);
	documentDir = fil[count].getParentFile().getAbsolutePath()+"/";
	}
	
}


private ImageIcon getImage(String codebase,String filename)
{
	String fullfilename = filename;
	ImageIcon source = null;
	URL url =null;
	try{
	url = new URL(codebase + fullfilename);
	}catch(Exception ex){
	System.out.println("Error: getImage problem");
	}
	source= new ImageIcon(url);
	return source;
}

public void addImage(LbImage lbimage, Dimension d)
	{
	setMaxX(d.width);  
	setMaxY(d.height); 
	imageList.add(lbimage);
	}

	/** full file name*/
	public int delImage(String imgName)
	{
	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(imgName))
		{
		  imageList.remove(num);
		  return 1; 
		}
	}
	return 0;
	}

	/**full file name */
	public LbImage getLbImage(String imgName)
	{

  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(imgName))
		{
		  return (LbImage)imageList.elementAt(num);
		}
	}
	return null;
	}

	public LbImage getLbImage(int num)
	{
	return (LbImage)imageList.elementAt(num);
	}

	public int getLx(int num)
	{
	return ((LbImage)imageList.elementAt(num)).getLx();
	}

	public int getLy(int num)
	{
	return ((LbImage)imageList.elementAt(num)).getLy();
	}

	public int getContrastVal(int num)
	{
	return ((LbImage)imageList.elementAt(num)).getContrastVal();
	}

	public boolean isGreyscale(int num)
	{
	return ((LbImage)imageList.elementAt(num)).isGreyscale();
	}

	public boolean isInvert(int num)
	{
	return ((LbImage)imageList.elementAt(num)).isInvert();
	}

	public int getNumImage()
	{
	return imageList.size();
	}


	public Rectangle getBounds(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return ((LbImage)imageList.elementAt(num)).getBounds();
		}
	}
	return null;
	}



	public ImageIcon getImageIcon(String imgName)
	{
			
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(imgName))
		{
			  return ((LbImage)imageList.elementAt(num)).getImageIcon();
		}
	}
	return null;
	}

	public int setImageIcon(String fullfileName, ImageIcon image)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  ((LbImage)imageList.elementAt(num)).setImageIcon(image);
		  return 1;
		}
	}
	return 0;
	}

	public int getPivotX(int num)
	{
		  return (((LbImage)imageList.elementAt(num)).getPivot()).x;
	}

	public int getPivotY(int num)
	{
		  return (((LbImage)imageList.elementAt(num)).getPivot()).y;
	}

	public int getPivotX(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return (((LbImage)imageList.elementAt(num)).getPivot()).x;
		}
	}
	return -1;
	}
	
	public int getPivotY(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return (((LbImage)imageList.elementAt(num)).getPivot()).y;
		}
	}
	return -1;
	}

	public int getmagWidth(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return ((LbImage)imageList.elementAt(num)).magWidth();
		}
	}
	return -1;
	}

	public int getmagWidth(int num)
	{
		  return ((LbImage)imageList.elementAt(num)).magWidth();
	}

	public int getmagHeight(int num)
	{
	  return ((LbImage)imageList.elementAt(num)).magHeight();
 	} 

	public int getWidth(int num)
	{
		  return ((LbImage)imageList.elementAt(num)).Width();
	}

	public int getHeight(int num)
	{
	  return ((LbImage)imageList.elementAt(num)).Height();
 	} 

	  public int getmagHeight(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return ((LbImage)imageList.elementAt(num)).magHeight();
		}
	}
	return -1;
	}

	public void setPivot(int x, int y, String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  ((LbImage)imageList.elementAt(num)).setPivot(x,y);
		}
	}

	}

	public void setPivot(int x, int y, int num)
		{
		
			  ((LbImage)imageList.elementAt(num)).setPivot(x,y);
		}
	
	
	
 public int showSelected( MouseEvent e){
  // now look on which image the mouse cursor has been clicked
  // the cursor x should be between  lx and hx and same for 
  // cursor y ly and hy
	int thisX = e.getX();
	int thisY = e.getY() - FUZZ ;
	selectedImage =getSelected(thisX,thisY);
	if(selectedImage == null)
	{
	lbimage =null;
	return 0;
	}
	if(selectedImage.size() != 0) 
	{
	lbimage = returnSelectedImage();
	} else {
	lbimage = null;
	}	
	countofselected = selectedImage.size();
  return countofselected;
  }

public int getGridX()
{
 return xGrid;
}

public int getGridY()
{
 return yGrid;
}


public void setGrid(int xgrid, int ygrid)
{
 xGrid = xgrid;
 yGrid = ygrid;
}

public void setGridY(int ygrid)
{
 yGrid= ygrid;
}

public void setGridX(int xgrid)
{
 xGrid= xgrid;
}


public String getFullFileName(String fileName)
 {
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).imageFile.
		 equalsIgnoreCase(fileName))
		{
		  return ((LbImage)imageList.elementAt(num)).getFileName();
		}
	}
	return null;
  }


public LbImage returnSelectedImage( ){
return (LbImage)selectedImage.lastElement();
} 





	public String getFileName(int num)
	{
		  return ((LbImage)imageList.elementAt(num)).getFileName();
	}

	public int getBrightVal(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return ((LbImage)imageList.elementAt(num)).getBrightVal();
		}
	}
	return -1;
	}

	public int getContrastVal(String fullfileName)
	{
	for(int num =0; num < imageList.size(); num++)
	{
		if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		  return ((LbImage)imageList.elementAt(num)).getContrastVal();
		}
	}
	return -1;
	}


	public void setBrightVal(String fullfileName, int val)
	{
	
	for(int num =0; num < imageList.size(); num++)
	{
		if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		 ((LbImage)imageList.elementAt(num)).setBrightVal(val);
		}
	}
	}



	public int getBrightVal(int num)
	{
		  return ((LbImage)imageList.elementAt(num)).getBrightVal();
	}


	public void setContrastVal(String fullfileName, int val)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		 ((LbImage)imageList.elementAt(num)).setContrastVal(val);
		}
	}
	}






	public int refreshImage()
	{
		if(lbimage == null)
		return 0;
		
	boolean success = false;
	URL url = null;	
	try{
  	url = new URL(lbimage.getCodeBase()+lbimage.getFileName());
	success = true;
	}catch(Exception ex){
	System.out.println("LbImageManager::Could not get image: "+url.toString());
	}
	if(success){
	ImageIcon source = null;	
	source =  new ImageIcon(url);
	if (source != null)
	  this.setImageIcon(lbimage.getFileName(),source);
	else 
	  return 0;
	}
	repaint();
	return 1;
	}	  


	public int getMaxX()
	{
	return maxX;
	}

	public int getMaxY()
	{
	return maxY;
	}

	private boolean setMaxX(int valx)
	{
	  if (maxX < valx)
	  {
		maxX = valx;
		return true;
	  }else
		return false;
	}

	private boolean setMaxY(int valy)
	{
	  if (maxY < valy)
	  {
		maxY = valy;
		return true;
	  }else
		return false;
	}

	public boolean setMax(int valx , int valy)
	{
	return setMaxX(valx) || setMaxY(valy);
	}

	public boolean updateCoordinate(int x, int y, int num)
	{
	  boolean changed = false;
	  int height = getmagHeight(num) ;
	  int width = getmagWidth(num) ;
	  if(x+width > maxX)
	  {
		maxX = x+width ;
		changed = true;
  	  }
	
	  if(y+height > maxY)
	  {
		maxY = y +height;
		changed = true;
	  } 
  
	 (this.getLbImage(num)).setImageCoordinate(x,y);

	return changed;	

	}

	public void setTileMagnification(int num)
	{
	  int height = getHeight(num) ;
	  int width = getWidth(num) ;
	  double ratio = TILE_X / width;
	  double ratio1 = TILE_X / height;
	  
	  if(ratio > ratio1)
		ratio = ratio1;

	  int r = (int)(ratio * 100);
	  
	  if(width > TILE_X)
	  (this.getLbImage(num)).setScreenResolution(r);

	}



	public boolean updateCoordinate(int x, int y, String fullfileName)
	{
	  boolean changed = false;
	  int height = getmagHeight(fullfileName) ;
	  int width = getmagWidth(fullfileName) ;
	  if(x+width > maxX)
	  {
		maxX = x+width ;
		changed = true;
  	  }
	
	  if(y+height > maxY)
	  {
		maxY = y +height;
		changed = true;
	  } 
  
	 (this.getLbImage(fullfileName)).setImageCoordinate(x,y);
	return changed;	
	}

	



	public boolean updateCoordinate(int x, int y, String fullfileName, boolean var)
	{
	  boolean changed = false;
	  int height = getmagHeight(fullfileName) ;
	  int width = getmagWidth(fullfileName) ;
	  if(x+width > maxX)
	  {
		maxX = x+width ;
		changed = true;
  	  }
	
	  if(y+height > maxY)
	  {
		maxY = y +height;
		changed = true;
	  } 
	  if(var == true)
	(this.getLbImage(fullfileName)).setImageCoordinate(x,y,true);
	  else
	(this.getLbImage(fullfileName)).setImageCoordinate(x,y);
	return changed;
	}





	public Point getUpper(int num)
	{
		return ((LbImage)imageList.elementAt(num)).getUpper();
	}
	public Point getUpper(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		return ((LbImage)imageList.elementAt(num)).getUpper();
		}
	}
	return null;
	}

	public Point getLower(int num)
	{
	return ((LbImage)imageList.elementAt(num)).getLower();
	}
  
	public Point getLower(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
		return ((LbImage)imageList.elementAt(num)).getLower();
		}
	}
	return null;
	}


	public Vector getSelected(int x, int y)
	{
	Vector selected = new Vector(20,2);
  	for(int num =0; num < imageList.size(); num++)
	{
    	if (((LbImage)imageList.elementAt(num)).isSelected(x,y))
		{
		selected.add(imageList.elementAt(num));
		}
	}

	if(selected.size()== 0)
  	return null;
	else
	return selected;
	}


	public boolean isVisible(String fullfileName) {
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
    	return ((LbImage)imageList.elementAt(num)).isVisible();
		}
	}
	return false;	
	}



	public boolean isVisible(int num)
	{
    	return ((LbImage)imageList.elementAt(num)).isVisible();
	}



	public void toggleDisplay(String fullfileName)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
    	if (((LbImage)imageList.elementAt(num)).isVisible())
		{
    	((LbImage)imageList.elementAt(num)).setVisible(false);
		return;	
		}
		else
		{
    	((LbImage)imageList.elementAt(num)).setVisible(true);
		return;
		}
		}
	}


	}


	public void setGreyscale(String fullfileName, boolean val)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
    	((LbImage)imageList.elementAt(num)).setGreyscale(val);
		return;
		}
		}
	}

	public void setScreenResolution(String fullfileName,int dpi)
	{
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
    	((LbImage)imageList.elementAt(num)).setScreenResolution(dpi);
		return;
		}

	}
	}

	public void setScreenResolution(int num,int dpi)
	{
    	((LbImage)imageList.elementAt(num)).setScreenResolution(dpi);
	}


	public void magnifyAll(String type){

  	for(int num =0; num < imageList.size(); num++)
	{
    int dpi= ((LbImage)imageList.elementAt(num)).getScreenResolution();
	if(type.equalsIgnoreCase("plus"))
	{

	if(dpi < SCALE_MAX)
	dpi = dpi + magnifyVal;
	else
	dpi = SCALE_MAX;

	} else{

  	if(dpi > SCALE_MIN)
	dpi = dpi - magnifyVal;
	else
	dpi = SCALE_MIN;
	
	}

    ((LbImage)imageList.elementAt(num)).setScreenResolution(dpi);
	}

	}

	public void moveTo(String fullfileName, Point p)
	{
		
  	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(fullfileName))
		{
    	((LbImage)imageList.elementAt(num)).setImageCoordinate(p.x,p.y);
		break;
		}
	}
	}
public void changePivot(String fullfileName, int x, int y)
{
  	Point upper = null;
	int magWidth;
	int magHeight;
	if(lbimage == null)
	return;
	
		if(lbimage != null && 
		lbimage.getFileName().equalsIgnoreCase(fullfileName))
		{
		upper = lbimage.getUpper();
		magWidth = lbimage.magWidth();
		magHeight = lbimage.magHeight();
		}
		else
		{
		upper=  getUpper(fullfileName);	  
		magWidth = getmagWidth(fullfileName);
		magHeight =getmagHeight(fullfileName);
		}
	
	if(x > upper.x && x < upper.x + magWidth &&  y > upper.y && y < 
	upper.y +magHeight + FUZZ )
	{
	if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
	lbimage.setPivot(x,y);
	else
	setPivot(x,y,fullfileName);	  
	}

}

public String getSelectedImageName()
{
if(lbimage != null)
  return lbimage.getFileName();
else
  return "error image"; // no image selected
}

 public void resetSelectedImage(){
  countofselected = 0;
  lbimage = null;
  if(selectedImage!= null && selectedImage.size() != 0)
  selectedImage.removeAllElements();
 }
 


	
	public void mouseClicked(MouseEvent e){
	}
	
	public void mousePressed(MouseEvent e){
	
	
	if(getMode()==1){
	resetSelectedImage();
	numSelected = showSelected(e);
	if(numSelected >0)
	{	
	    currentImage = getSelectedImageName();
	}else{
	  /*System.out.println("---------------------------------");
 	  System.out.println("User Not selected any thing ");
      System.out.println("mouse event:X andY: "+e.getX()+" "+ e.getY());
      */
	}
	if(currentImage != null){
	changePivot(currentImage,e.getX(), e.getY());
	}
	}else if(getMode()==0){
	  setMode(1);
	}

	this.repaint();
	}

	public void mouseReleased(MouseEvent event){

	}
	
	public void mouseExited(MouseEvent event){

	}
	
	public void mouseEntered(MouseEvent event){

	}

	public void mouseDragged(MouseEvent e){
	if(currentImage == null)
	return;


	int movex =  getGridX() * (int)Math.ceil(e.getX()/getGridX());
	int movey =  getGridY() * (int) Math.ceil((e.getY()-FUZZ)/getGridY());       
	

	if(getMode()== 1){
	Point newPt = new Point(movex,movey); 
	
	upDateCoordinate(movex,movey ,currentImage);
	moveTo(newPt,currentImage);
	this.repaint();
	prevX = movex;
	prevY = movey; 
	}else {

	}




}
	
	public void mouseMoved(MouseEvent event){}


  public void setMode(int modeType)
  {
  mode = modeType;
  }

  public int getMode()
  {
  return mode;
  }
  
  
  
  public void upDateCoordinate(int x, int y, String fullfileName) {
	if(lbimage != null && 
	  lbimage.getFileName().equalsIgnoreCase(fullfileName))
	  //? here  added fuzz
	{
	lbimage.setImageCoordinate(x,y);	
	setMax(x,y);
	updateCoordinate(x,y,fullfileName);
   
	}
  }

  public void moveTo(Point p, String fullfileName)
  {	
	if(getNumImage() == 0)
	return;
	if(numSelected ==0)
	return;

  if(getMode()==1){
  
  if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
    { 
  	lbimage.setImageCoordinate(p.x, p.y+FUZZ,true);  	
	if(setMax(p.x,p.y)){
  	//incPanelSize(p.x,p.y);
	}	  
	revalidate();
  } else {
	if(updateCoordinate(p.x,p.y+FUZZ,fullfileName,true))
    //incPanelSize(p.x+lbimage.magWidth(),p.y+FUZZ+lbimage.magHeight());
	
	revalidate();
	}
	}
	return;
   }  
public void magnify(String imgName, int sc){
paintImage(sc,imgName);
this.repaint();
}

public void bright(){
Image curImg =  getImage(currentImage);
try { 
PlugInFilter pif = (PlugInFilter) Class.forName("Bright").newInstance();
Image fImg = pif.filter(this, curImg,brightVal/100);
//? HOWTO setImage(fImg,imgNum);
this.repaint();
}catch (Exception exx) { 
System.out.println("Class not found");   
}
lbimage.setBrightVal(getBrightVal(currentImage)+brightVal);
}

public void bright(String fileName,int val){
String FullFileName = getFullFileName(fileName);
if(FullFileName == null) return;
Image curImg =  getImage(FullFileName);

try { 
PlugInFilter pif = (PlugInFilter) Class.forName("Bright").newInstance();
Image fImg = pif.filter(this, curImg,brightVal/100);
//? HOWTO setImage(fImg,imgNum);
this.repaint();
} catch (Exception exx) { 
System.out.println("Class not found");   
}
}


public void invert(){
  Image curImg =  getImage(currentImage);
  try { 
  PlugInFilter pif = 
  (PlugInFilter) Class.forName("Invert").newInstance();
    Image fImg = pif.filter(this, curImg,0);
    setImage(fImg,currentImage);
 	this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
	lbimage.setInvert(!lbimage.imageop.invert);
}

public void invert(String imgName){
  Image curImg =  getImage(imgName);   
try { 
  PlugInFilter pif = 
  (PlugInFilter) Class.forName("Invert").newInstance();
  	Image fImg = pif.filter(this, curImg,0);
	setImage(fImg,imgName);  
 	this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
  }

  
public void greyscale(){
Image curImg =  getImage(currentImage);
  setGreyscale(currentImage,true);
try { 
  PlugInFilter pif = 
  (PlugInFilter) Class.forName("Grayscale").newInstance();
    Image fImg = pif.filter(this, curImg,0);
    setImage(fImg,currentImage);
 	this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
	lbimage.setGreyscale(!lbimage.imageop.greyscale);
  }

public void greyscale(String imgName){
  Image curImg =  getImage(imgName);
  setGreyscale(currentImage,true);
try { 
  PlugInFilter pif = 
  (PlugInFilter) Class.forName("Grayscale").newInstance();
    Image fImg = pif.filter(this, curImg,0);
    setImage(fImg,imgName);
 	this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
  }

public void visible(String imgName){
	for(int num =0; num < imageList.size(); num++)
	{
    	if(((LbImage)imageList.elementAt(num)).getFileName().
		 equalsIgnoreCase(imgName))
		{
		  
		  if((LbImage)imageList.elementAt(num) == lbimage)
		  {
			((LbImage)imageList.elementAt(num)).toggle();
			((LbImage)selectedImage.firstElement()).toggle();
		  	lbimage.toggle();		  	
		  }else{
			((LbImage)imageList.elementAt(num)).toggle();
		  }
		  
		}
	}
	
	this.repaint();
	//this.revalidate();
	//System.out.println("After validate and repaint");
}


/* FUTURE USE ! 
  public void blur(){
  }
  public void blur(String imgName){
  System.out.println("LbImageManager::In Blur");
  }
  
  public void sharpen(){
  System.out.println("LbImageManager::In Sharpen");
  }

  public void sharpen(String imgName){
  System.out.println("LbImageManager::In sharpen");
  }
*/

  public void contrastless(String imgName,int val){
  Image curImg =  getImage(imgName);
   try { 
    PlugInFilter pif = (PlugInFilter) Class.forName("Contrast").newInstance();
    Image fImg = pif.filter(this, curImg,val/100);
    setImage(fImg,imgName);
    this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
    
    
  }


  public void contrastless(){
  //System.out.println("LbImageManager::In contrastless");
  Image curImg =  getImage(currentImage);
  setContrastVal(currentImage, getContrastVal(currentImage) - contrastVal);
  double dbl = new Double(contrastVal/100.0).doubleValue();
   try { 
    PlugInFilter pif = (PlugInFilter) Class.forName("Contrast").newInstance();
    Image fImg = pif.filter(this, curImg,-1*dbl);
    setImage(fImg,currentImage);
    this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
	//System.out.println("Aggregate Contrast is: "+ getContrastVal(currentImage));
   }




  public void contrast(String imgName, int val){
  //System.out.println("LbImageManager::In contrast");
  Image curImg =  getImage(imgName);
  double dbl = new Double(val/100.0).doubleValue();
  try { 
    PlugInFilter pif = (PlugInFilter) Class.forName("Contrast").newInstance();
    Image fImg = pif.filter(this, curImg,dbl);
    setImage(fImg,imgName);
    this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
 }


  public void contrast(){
  System.out.println("LbImageManager::In contrast");
  Image curImg =  getImage(currentImage);
  double dbl = new Double(contrastVal/100.0).doubleValue();
  try { 
    PlugInFilter pif = (PlugInFilter) Class.forName("Contrast").newInstance();
    Image fImg = pif.filter(this, curImg,dbl);
    setImage(fImg,currentImage);
    this.repaint();
    } catch (Exception exx) { 
      System.out.println("Class not found");   
    }
	setContrastVal(currentImage, getContrastVal(currentImage)+ contrastVal);
	//System.out.println("Aggregate Contrast is: "+ getContrastVal(currentImage));
	
 }


  public void setImage(Image img,String fullfileName)
  {
  if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
  	lbimage.setImageIcon(new ImageIcon(img));
	else
	setImageIcon(fullfileName,new ImageIcon(img));	  
  }

   public void setImageIcon(ImageIcon img, String fullfileName)
   {
  if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
  	lbimage.setImageIcon(img);
	else
	setImageIcon(fullfileName,img);	  
  repaint();
  } 

  
public Image getImage(String fullfileName)
{	
	return (getImageIcon(fullfileName)).getImage();
}


   private void paintImage()
  {
    Rectangle bounds;
    setScreenResolution(currentImage,ScreenRes * scale / 100);
    try { bounds = getBounds(currentImage); }
    catch (NoSuchMethodError e) { bounds = getBounds(); }
    x0 = (bounds.width - magWidth(currentImage)) / 2;
    y0 = (bounds.height - magHeight(currentImage)) / 2;
	
	Rectangle rect = 
	new Rectangle((magWidth(currentImage))/100,(magHeight(currentImage))/100);
    this.scrollRectToVisible(rect);	

    this.repaint(); 
  }


   private void paintImage(int val, String fullfileName)
  {
    Rectangle bounds;
	if(val ==0)
  	setScreenResolution(fullfileName,ScreenRes * val / 100);
    try { bounds = getBounds(fullfileName); }
    catch (NoSuchMethodError e) { bounds = this.getBounds(); }
    x0 = (bounds.width - magWidth(fullfileName)) / 2;
    y0 = (bounds.height - magHeight(fullfileName)) / 2;
	Rectangle rect = 
	new Rectangle((magWidth(currentImage))/100,(magHeight(currentImage))/100);
    this.scrollRectToVisible(rect);		
    this.repaint(); 
  }


   public int magWidth(String fullfileName)
  { 
  	if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
  	return lbimage.magWidth();
	else
	return getmagWidth(fullfileName);	  
  }

   public int magHeight(String fullfileName)
  { 
  	if(lbimage != null && 
	lbimage.getFileName().equalsIgnoreCase(fullfileName))
  	return lbimage.magHeight();
	else
	return getmagHeight(fullfileName);	  
  }


/**
 * @param wkspace2
 */
public void setWorkspace(WorkSpace wkspace2) {
	wkspace = wkspace2;	
}




}
