/*

<The Virtual Lightbox Applet: An image editing applet>
    Copyright (C) <2003>  <University of Maryland>
@Author: Amit Kumar	
Code Released under GPL
@date Jan 19th 2003
@modified date Jan 23rd 2003
@last modified on Dec 25th 2003, 10:38 am @ DEL

**/


/*
 * LightApp.java
 *
 * Created on Dec 25th, 2002, 5:02 pm @ JFK 
*/


import java.awt.Image;
import java.awt.*;
import java.net.*;

import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;

import javax.swing.*;
import javax.swing.JScrollPane;
import javax.swing.JScrollBar;
import javax.swing.JPanel;
public class LightApp extends javax.swing.JApplet {
  final Color brown = new Color(102,51,0);
  final Color white = new Color(255,255,255);
  final String CNAME = "lightbox_applet";
  private WorkSpace wkspace;
  final int IMR = 100; //image resolution
  int MAX_FILES = 10;
  final Color frameColor = new Color(0,255,0);
  final int FRAME_WIDTH = 2;
  int width = 1024;
  int height = 768;
	
    /** Creates new form VMImage */
    public LightApp() {
	wkspace = new WorkSpace();
	toolBar = new JToolBar();
	//toolBar.setBackground(brown);
	lbmanager.setBackground(white);
	bp = new ButtonPanel(lbmanager);
	//scrollPane = new JScrollPane(lbmanager,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	scrollPane = new JScrollPane(lbmanager);
	scrollPane.setBackground(white);
	JComponent cornerlabel = new JLabel("");
	cornerlabel.setBackground(white);
	cornerlabel.setOpaque(true);
	JScrollBar scrollbar1 = scrollPane.getHorizontalScrollBar();

	scrollbar1.setBackground(brown);	

	scrollPane.setCorner(JScrollPane.LOWER_RIGHT_CORNER,cornerlabel);
	cl = this.getClass().getClassLoader();
	lbmanager.setWorkspace(wkspace);
	addButtons(toolBar);
	JPanel contentPane = new JPanel();
	contentPane.setLayout(new BorderLayout());
	contentPane.setPreferredSize(new Dimension(100,100));
	contentPane.add(toolBar,BorderLayout.NORTH);
	contentPane.add(scrollPane,BorderLayout.CENTER);
	contentPane.add(bp,BorderLayout.SOUTH);
	setContentPane(contentPane);
	wkspace.setLbImageManager(lbmanager);
		
	
	validate();
    }

		
	
  /**
	 * 
	 */


	protected void addButtons(JToolBar toolBar) {
   
        JButton button = new JButton();
	 
        button = new JButton(new ImageIcon(cl.getResource("applet-images/tile.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("tile");
		button.addActionListener(lbmanager);
		button.setToolTipText("Tile Images");
		toolBar.add(button);
        //second button
        

        button =new JButton(new ImageIcon(cl.getResource("applet-images/magnify.gif")));
	   //button.setBackground(brown);	
		button.setActionCommand("plus");
		button.addActionListener(lbmanager);
		button.setToolTipText("Magnify");
		toolBar.add(button);

        button = new JButton(new ImageIcon(cl.getResource("applet-images/minus.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("minus");
		button.addActionListener(lbmanager);
		button.setToolTipText("De-magnify");
		toolBar.add(button);

        button = new JButton(new ImageIcon(cl.getResource("applet-images/contrastplus.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("contrast");
		button.addActionListener(lbmanager);
		button.setToolTipText("Increase Contrast");
        toolBar.add(button);

       button = new JButton(new ImageIcon(cl.getResource("applet-images/contrastminus.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("contrastless");
		button.addActionListener(lbmanager);
		button.setToolTipText("Decrease Contrast");
        toolBar.add(button);

        button = new JButton(new ImageIcon(cl.getResource("applet-images/greyscale.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("greyscale");
		button.addActionListener(lbmanager);
		button.setToolTipText("Convert to GreyScale");
        toolBar.add(button);

        button = new JButton(new ImageIcon(cl.getResource("applet-images/invert.gif")));
	    //button.setBackground(brown);	
		button.setActionCommand("invert");
		button.addActionListener(lbmanager);
		button.setToolTipText("Invert Image");
		toolBar.add(button);


		button = new JButton(new ImageIcon(cl.getResource("applet-images/refreshimage.gif")));
	 	button.setActionCommand("refreshImage");
		button.addActionListener(lbmanager);
		button.setToolTipText("Get Orignal image");
        toolBar.add(button);
	
	toolBar.addSeparator();

	  button = new JButton(new ImageIcon(cl.getResource("applet-images/open.gif")));
      button.setActionCommand("openwkspace");
	  button.addActionListener(lbmanager);
	  button.setToolTipText("Open Workspace");
	  toolBar.add(button);

	  button = new JButton(new ImageIcon(cl.getResource("applet-images/save.gif")));
	  button.setActionCommand("savewkspace");
	  button.addActionListener(lbmanager);
	  button.setToolTipText("Save the Workspace");
	  toolBar.add(button);

	  button = new JButton(new ImageIcon(cl.getResource("applet-images/add.gif")));
	  button.setActionCommand("addimage");
	  button.addActionListener(lbmanager);
	  button.setToolTipText("Add Image");
	  toolBar.add(button);


	  button = new JButton(new ImageIcon(cl.getResource("applet-images/clear.gif")));
	  button.setActionCommand("clear");
	  button.addActionListener(lbmanager);
	  button.setToolTipText("Clear Workspace");
	  toolBar.add(button);

    }		
 

  public void stop(){
	super.stop();
  }

  public void setSize(int width, int height){
	super.setSize(width,height);
	validate();
  }

  public void resize(int w, int h){
    super.resize(w,h);
	}


    public void init(){
	 boolean tile = false;
	String tmp = getParameter("num");
	numfiles = (new Integer(tmp)).intValue();

	tmp = getParameter("width");
	width= (new Integer(tmp)).intValue();

	tmp = getParameter("height");
	height = (new Integer(tmp)).intValue();

	tmp = getParameter("tile");

	if(tmp.equalsIgnoreCase("yes"))
	tile = true;
	else 
	tile = false;

	URL codebase = getCodeBase();
	System.out.println("CODE BASE IS: "  + codebase.toString());
	lbmanager.setCodeBase(codebase);
	lbmanager.setWidthHeight(width,height);
   	System.out.println("codebase is : "+codebase);
	ImageIcon img;
	ImageIcon imgsmall;
	LbImage lbimage=null;
	Dimension dim;
//	URL url = null;
	boolean urlokay = false;
	int num_found=0;
	for(int count =0 ; count < numfiles; count++)
	{
	
	fileName[count] = new String();
    String temp_fname= new String("filename"+((new Integer(count)).toString()));
    String temp_title =new String("title"+((new Integer(count)).toString()));
	fileName[count] = getParameter(temp_fname);
	title[count] = getParameter(temp_title);
	if(title[count]== null)
	title[count]= fileName[count];
    urlokay=true;
	if(urlokay){
	Image image  = getImage(getCodeBase(),fileName[count]);
	img = new ImageIcon(image);
	if(img.getIconHeight()==-1){
		JOptionPane.showMessageDialog(this,"Image \""+fileName[count]+"\" could not be retrieved.");				
	}else{
	lbimage = new LbImage(img,fileName[count],title[count],CNAME,IMR,getCodeBase().toString());
	dim = new Dimension(img.getIconWidth(), img.getIconHeight());
	imgsmall = new ImageIcon(img.getImage().getScaledInstance(30,30,Image.SCALE_DEFAULT)); 
	lbmanager.addImage(lbimage,dim);	
	bp.addButton(imgsmall,title[count],fileName[count]);
	num_found++;
	}	
	}

	if(tile)
	lbmanager.tileImages();

	}

	setSize(width,height);
	lbmanager.setButtonPanel(bp);
	numfiles = num_found;
	this.repaint();
	}

		  




	private String fileName[] = new String[MAX_FILES];
	private String title[] = new String[MAX_FILES];
	private LbImageManager lbmanager  = new LbImageManager();
	private int numfiles = 0;
	private JToolBar toolBar;
	private ButtonPanel bp;

	private JScrollPane scrollPane;	
	ClassLoader cl;

}
