/*
<The Virtual Lightbox Applet: An image editing applet>
Copyright (C) <2003>  <University of Maryland>
Code Released under GPL
@Author: Amit Kumar
@date-modified Dec 25th 2003 @DEL
@date-modified Dec 28th 2003 @JMN
@date-modified Dec 29th 2003 @JMN
@date-modified Jan 2nd 2004 @JMN
@last-date-modified Jan 27th 2004 @CP
*/


/*    
 <The Virtual Lightbox: An image editing whiteboard application>
  Copyright (C) <2001>  <University of Kentucky>
  Mathew G. Kirschenbaum, Jerzy W. Jaromczyk, Amit Kumar 
*/

import java.io.*;
import java.net.URL;
import java.util.*;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import java.awt.Dimension;
import java.awt.Image;
public class WorkSpace {
  String defaultWorkspaceDir="";
  final String WORKSPACE_EXTN = "vlb";
  int ImageResolution = 100;
  private LbImageManager lbm;
 public WorkSpace(){
   //ImageResolution = imgRes;
 }

 public void createWorkSpace(){
  
 String fname="";
 String sessionName ="" ;
 LbImage lbimage;
 if(lbm == null)
 return;
 
 JFileChooser chooser = new JFileChooser();
 if(defaultWorkspaceDir != null){
 if((new File(defaultWorkspaceDir)).exists())
 chooser.setCurrentDirectory(new File(defaultWorkspaceDir)); 
 }
	chooser.setDialogTitle("Save Lightbox Session");
	chooser.setDialogType(JFileChooser.SAVE_DIALOG);
	chooser.setToolTipText("Save Lightbox Session for latter use");
     ExtFilter filter = new ExtFilter(WORKSPACE_EXTN);
     filter.setDescription("Lightbox Session File");
	 chooser.setFileFilter(filter);

	 
		 
	 int returnVal = chooser.showSaveDialog(this.lbm);
	 if(returnVal == JFileChooser.APPROVE_OPTION) {
	 fname = chooser.getSelectedFile().getAbsolutePath();
	 defaultWorkspaceDir = chooser.getSelectedFile().getParent();
	 }else{
	 // on cancel
	 return;
	 }
	 
	 if(fname==null)
	 return;

 
 
 
 int numImage = lbm.getNumImage();
 FileWriter fwrite;
 try{
 fwrite = new FileWriter(fname+"."+WORKSPACE_EXTN);
 fwrite.write(numImage+"\n");
 //fwrite.write(this.lbm.codebase.toString()+"\n");
 for(int i = 0; i< numImage; i++){
 lbimage = lbm.getLbImage(i);
 fwrite.write(lbimage.getCodeBase()+","+lbimage.getFileName() + ","+ lbimage.getLx() +"," + lbimage.getLy() +"," 
 + lbimage.getHx() +","+  lbimage.getHy() +","+ lbimage.getBrightVal() +","+ 
 lbimage.getContrastVal()+","+ lbimage.getScreenResolution()+ "," + lbimage.isVisible() 
 + "," + lbimage.isGreyscale()+ ","+ lbimage.isInvert()+","+ lbimage.getTitle()+" \n");
 }
 fwrite.close();
 } catch (Exception e){
 	System.out.println("Problem Saving Workspace");
 	System.out.println(e.getMessage());
 }
 
} 

 


 public void openWorkSpace(){
  String s;
   String codebase=""; 
  String  inString =" ";
  String delimiters = ",";   
  StringTokenizer tokenCollection;
  String fname="";


  
  int num = 0;
  LbImage lbimage;

  JFileChooser chooser = new JFileChooser();
  if(defaultWorkspaceDir != null){
  if((new File(defaultWorkspaceDir)).exists())
  chooser.setCurrentDirectory(new File(defaultWorkspaceDir)); 
  }
	 chooser.setDialogTitle("Open Lightbox Session");
	 chooser.setDialogType(JFileChooser.OPEN_DIALOG);
	 chooser.setToolTipText("Open Lightbox Session");
	  ExtFilter filter = new ExtFilter(WORKSPACE_EXTN);
	  filter.setDescription("Lightbox Session File");
	  chooser.setFileFilter(filter);
	 	 	 
	  int returnVal = chooser.showOpenDialog(this.lbm);
	  if(returnVal == JFileChooser.APPROVE_OPTION) {
	  fname = chooser.getSelectedFile().getAbsolutePath();
	  defaultWorkspaceDir = chooser.getSelectedFile().getParent();
	  }else{
		 return ;
	  }
	 
	  if(fname==null)
	  return ;
	  this.lbm.imageList.clear();
	  
  try{
  FileReader fr = new FileReader(fname);
  BufferedReader br = new BufferedReader(fr);
  
   if ((s = br.readLine()) != null) 
   num = Integer.parseInt(s);
  
   if(num ==0 )
   return ;

  int lx,ly,hx,hy,brightVal,contrastVal,screenResolution;
  boolean invert,greyscale,visible;
  String Fname,FullFileName,title;
  ImageIcon img = null;
  
  // get ready to get new images
  lbm.getButtonPanel().removeAllButton();
  
  for(int i=0; i< num;i++) {
  s = br.readLine();
  inString = s;  
            tokenCollection = new StringTokenizer( inString, delimiters );	     
			codebase = tokenCollection.nextToken();
			FullFileName =   tokenCollection.nextToken();
            Fname = this.getFileName(FullFileName);
			lx =   Integer.parseInt(tokenCollection.nextToken());    
			ly =   Integer.parseInt(tokenCollection.nextToken());
			hx =   Integer.parseInt(tokenCollection.nextToken());
			hy =   Integer.parseInt(tokenCollection.nextToken());
			brightVal =   Integer.parseInt(tokenCollection.nextToken());
			contrastVal =   Integer.parseInt(tokenCollection.nextToken());
			screenResolution = 	Integer.parseInt(tokenCollection.nextToken());
			visible = Boolean.valueOf(tokenCollection.nextToken()).booleanValue();
			greyscale = Boolean.valueOf(tokenCollection.nextToken()).booleanValue();
			invert = Boolean.valueOf(tokenCollection.nextToken()).booleanValue();
			title = tokenCollection.nextToken();
			img = getImage(codebase,FullFileName);
			
			if(img.getIconHeight()==-1){
			img = null;
		//	System.out.println("WORKSPACE::IMG IS NULL");
			JOptionPane.showMessageDialog(this.lbm,"Image \""+FullFileName+"\" could not be retrieved from: " + codebase);
			}else{
						
		lbimage = new LbImage(img,FullFileName,title,"self",ImageResolution,codebase);
		lbimage.setImageCoordinate(lx,ly,hx,hy);
		lbimage.setBrightVal(brightVal);
		lbimage.setContrastVal(contrastVal);
		lbimage.setScreenResolution(screenResolution);
		lbimage.setInvert(invert);
		lbimage.setGreyscale(greyscale);
		lbimage.setVisible(visible);
		lbimage.setTitle(title);
		
		lbm.addImage(lbimage, new Dimension(img.getIconWidth(),img.getIconHeight()));
		ImageIcon imgsmall = new ImageIcon(img.getImage().getScaledInstance(30,30,Image.SCALE_DEFAULT)); 
		lbm.getButtonPanel().addButton(imgsmall,title,FullFileName);
		 if(invert){
				lbm.invert(lbimage.getFileName());
			}	
			if(greyscale){
				  lbm.greyscale(lbimage.getFileName());
			}
			//lbm.bright(lbimage.getFileName(),brightVal);
			lbm.contrast(lbimage.getFileName(),contrastVal);	
		    	
			}
  }
   lbm.getButtonPanel().revalidate();
   fr.close();
  }catch (Exception e){
  	System.out.println("Workspace error:");
  	System.out.println(e.getMessage());
  	System.out.println("FILE NAME IS "+ fname);
  	}
  System.out.println("After Loading workspace");
  lbm.resetSelectedImage();
  lbm.revalidate();
  lbm.repaint();
 }
 

public void setLbImageManager(LbImageManager lbm2) {
	lbm = lbm2;	
}

private LbImageManager getLbImageManager() {
	return lbm;	
}



private ImageIcon getImage(String codebase,String filename)
{
	String fullfilename = filename;
	ImageIcon source = null;
	URL url =null;
	try{
	url = new URL(codebase + fullfilename);
	}catch(Exception ex){
		System.out.println("Error: getImage problem");
	}
	
	if(url==null)
	return null;
	
	source= new ImageIcon(url);	
	return source;
}

private void parseString( String s ,String fullName, int lx, int ly, int hx, int hy){
       String  inString = s;
// now i want to get the name of the image only to remove the path trash 
        String delimiters = " ";   
        StringTokenizer tokenCollection;
        if ( delimiters == null ) {
            tokenCollection = new StringTokenizer( inString );
            System.out.println( "Using default delimiters" );
        }
        else {
            tokenCollection = new StringTokenizer( inString, delimiters );
        }

//        while ( tokenCollection.hasMoreTokens() )
            {
            fullName =   tokenCollection.nextToken();
            lx =   Integer.parseInt(tokenCollection.nextToken());    
            ly =   Integer.parseInt(tokenCollection.nextToken());    
            hx =   Integer.parseInt(tokenCollection.nextToken());    
            hy =   Integer.parseInt(tokenCollection.nextToken());    
            }



}


 
public String getFileName( String fullPath) {
       String rawImageName = "errorImage";
// now i want to get the name of the image only to remove the path trash 
        String delimiters = ":\\";   
        String text = fullPath;
        StringTokenizer tokenCollection;
  
      char[] delme = new char[1000];     
       delme = text.toCharArray();
      for(int i =0; i< text.length();i++)
      {
      if(delme[i] == '\\'){
       delimiters = ":\\";	// recieving file from windows
       break;
       }
      if(delme[i] == '/'){
       delimiters = "/";	// recieving file from unix and clones
       break;
       }
      }



        if ( delimiters == null ) {
            tokenCollection = new StringTokenizer( text );
            System.out.println( "Using default delimiters" );
        }
        else {
            tokenCollection = new StringTokenizer( text, delimiters );
        }

        while ( tokenCollection.hasMoreTokens() )
            {
            rawImageName =   tokenCollection.nextToken();
            }
        return rawImageName;
  }






}
